//
//  Shaders.metal
//  Test2
//
//  Created by Caroline Begbie on 18/2/21.
//

#include <metal_stdlib>
using namespace metal;


kernel void bitonicSort(device float *floats [[buffer(0)]],
                        device int *uInts [[buffer(1)]],
                        constant int   &p       [[ buffer(2) ]],
                        constant int   &q       [[ buffer(3) ]],
                        uint gid [[thread_position_in_grid]]) {

  int pMinusQ = p-q;
  int distance = 1 << pMinusQ;
  uint gidShiftedByP = gid >> p;

  // True: Increasing / False: Descreasing
  bool direction = (gidShiftedByP & 2) == 0;
  uint gidDistance = (gid & distance);
  bool isGidDistanceZero = (gidDistance == 0);

  uint gidPlusDistance = (gid | distance);

  bool isLowerIndexGreaterThanHigher = (floats[gid] > floats[gidPlusDistance]);
  if (isGidDistanceZero && isLowerIndexGreaterThanHigher == direction) {
    float temp = floats[gid];
    floats[gid] = floats[gidPlusDistance];
    floats[gidPlusDistance] = temp;

    int temp2 = uInts[gid];
    uInts[gid] = uInts[gidPlusDistance];
    uInts[gidPlusDistance] = temp2;
  }
}
